//-----------------------------------------------------------------------------
// 
// 		cwCu		Windowspt@C֌WvO
// 
//  	Ver 3.14a
// 
//-----------------------------------------------------------------------------

// cwCu쐬p`
#define __DX_MAKE

// CN[h ---------------------------------------------------------------
#include "DxFileWin.h"
#include "DxWindow.h"
#include "../DxFile.h"
#include "../DxLog.h"
#include "../DxChar.h"
#include "../DxBaseFunc.h"
#include <windows.h>

#ifdef DX_USE_NAMESPACE

namespace DxLib
{

#endif // DX_USE_NAMESPACE

// }N` -----------------------------------------------------------------

// \̐錾 -----------------------------------------------------------------

// f[^` -----------------------------------------------------------------

// ֐錾 -------------------------------------------------------------------

DWORD	WINAPI		FileAccessThreadFunction( void *FileAccessThreadData ) ;					// t@CANZXpXbhp֐
int					SetFilePointer64( HANDLE FileHandle, ULONGLONG Position ) ;					// t@C̃ANZXʒuݒ肷( 0:  -1:s )

// vO -----------------------------------------------------------------

// t@C̃ANZXʒuݒ肷
int SetFilePointer64( HANDLE FileHandle, ULONGLONG Position )
{
	DWORD High, Low ;
	DWORD Result ;

	Low = ( DWORD )Position ;
	High = ( DWORD )( Position >> 32 ) ;
	Result = SetFilePointer( FileHandle, ( LONG )Low, ( LONG * )&High, FILE_BEGIN ) ;
	if( Result == 0xffffffff && GetLastError() != NO_ERROR )
	{
		return -1 ;
	}

	return 0 ;
}

// e|t@C쐬
extern HANDLE CreateTemporaryFile( wchar_t *TempFileNameBuffer )
{
	wchar_t String1[FILEPATH_MAX], String2[FILEPATH_MAX] ;
	HANDLE FileHandle ;
	int Length ;

	// e|t@C̃fBNgpX擾
	if( GetTempPathW( 256, String1 ) == 0 ) return NULL ;

	// ̍ŌɁ}[N
	Length = _WCSLEN( String1 ) ;
	if( String1[ Length - 1 ] != L'\\' )
	{
		String1[ Length     ]  = L'\\' ;
		String1[ Length + 1 ]  = L'\0' ;
	}

	// e|t@C̃t@C쐬
	if( GetTempFileNameW( String1, L"tmp", 0, String2 ) == 0 ) return NULL ;

	// tpXɕϊ
	ConvertFullPathW_( String2, String1 ) ;

	// e|t@CJ
	DeleteFileW( String1 ) ;
	FileHandle = CreateFileW( String1, GENERIC_WRITE, 0, NULL, CREATE_NEW, FILE_ATTRIBUTE_NORMAL, NULL ) ;
	if( FileHandle == NULL )
	{
		return NULL ;
	}

	// e|t@Cۑ
	if( TempFileNameBuffer != NULL )
	{
		_WCSCPY( TempFileNameBuffer, String1 ) ;
	}

	// nhԂ
	return FileHandle ;
}



// t@CANZXpXbhp֐
DWORD WINAPI FileAccessThreadFunction( void *FileAccessThreadData )
{
	FILEACCESSTHREAD *dat = (FILEACCESSTHREAD *)FileAccessThreadData ;
	DWORD res, ReadSize ;

	for(;;)
	{
		for(;;)
		{
			// LbVgpǂŏ𕪊
			if( dat->CacheBuffer )
			{
				// w߂܂łƑ҂
				res = WaitForSingleObject( dat->FuncEvent, 100 ) ;

				// w߂ĂꍇŃt@CJĂꍇ̓LbVOs
				if( res == WAIT_TIMEOUT && dat->Handle != NULL )
				{
					// LbVt牽Ȃ
					if( dat->CacheSize != FILEACCESSTHREAD_DEFAULT_CACHESIZE )
					{
						// ǂݍ݊JnʒuZbg
						SetFilePointer64( dat->Handle, dat->CachePosition + dat->CacheSize ) ;

						// ǂݍ
						ReadFile( dat->Handle, &dat->CacheBuffer[dat->CacheSize], ( DWORD )( FILEACCESSTHREAD_DEFAULT_CACHESIZE - dat->CacheSize ), &ReadSize, NULL ) ;
						
						// LȃTCY𑝂₷
						dat->CacheSize += ( LONGLONG )ReadSize ;
					}
				}
				else
				{
					break ;
				}
			}
			else
			{
				// w߂܂ő҂
				res = WaitForSingleObject( dat->FuncEvent, INFINITE ) ;
				if( res == WAIT_TIMEOUT && dat->Handle != NULL ) continue;
				break;
			}
		}

//		WaitForSingleObject( dat->FuncEvent, INFINITE ) ;

		// Cxg̃VOiԂ
		ResetEvent( dat->FuncEvent ) ;
		ResetEvent( dat->CompEvent ) ;

		// w߂画f
		switch( dat->Function )
		{
		case FILEACCESSTHREAD_FUNCTION_OPEN :
			dat->Handle = CreateFileW( dat->FilePath, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL ) ;
			if( dat->Handle == INVALID_HANDLE_VALUE )
			{
				dat->ErrorFlag = TRUE ;
				goto END ;
			}
			break ;

		case FILEACCESSTHREAD_FUNCTION_CLOSE :
			CloseHandle( dat->Handle ) ;
			dat->Handle = NULL ;
			break ;

		case FILEACCESSTHREAD_FUNCTION_READ :
			// LbVƓǂݍ݈ʒuvĂꍇ̓LbVf[^]
			if( dat->CacheBuffer && dat->ReadPosition == dat->CachePosition && dat->CacheSize != 0 )
			{
				DWORD MoveSize ;

				// ]TCY𒲐
				MoveSize = dat->ReadSize ;
				if( MoveSize > dat->CacheSize ) MoveSize = ( DWORD )dat->CacheSize ;

				// ]
				_MEMCPY( dat->ReadBuffer, dat->CacheBuffer, MoveSize ) ;

				// ǂݍ݃TCYƓǂݍ݈ʒuړ
				dat->ReadBuffer = (void *)( (BYTE *)dat->ReadBuffer + MoveSize ) ;
				dat->ReadPosition += MoveSize ;
				dat->ReadSize -= MoveSize ;
				
				// LbV̏XV
				dat->CachePosition += MoveSize ;
				dat->CacheSize     -= MoveSize ;
				if( dat->CacheSize != 0 ) _MEMMOVE( &dat->CacheBuffer[0], &dat->CacheBuffer[MoveSize], ( size_t )dat->CacheSize ) ;
			}

			// ]̃f[^Sēǂ߂ĂȂꍇ͍XɃt@Cǂݍ
			if( dat->ReadSize != 0 )
			{
				SetFilePointer64( dat->Handle, dat->ReadPosition ) ;
				ReadFile( dat->Handle, dat->ReadBuffer, dat->ReadSize, &dat->ReadSize, NULL ) ;

				// LbV
				if( dat->CacheBuffer )
				{
					dat->CachePosition = dat->ReadPosition + dat->ReadSize ;
					dat->CacheSize = 0 ;
				}
			}
			break ;

		case FILEACCESSTHREAD_FUNCTION_SEEK :
			SetFilePointer64( dat->Handle, dat->SeekPoint ) ;

			// LbV
			if( dat->CacheBuffer )
			{
				dat->CachePosition = (DWORD)dat->SeekPoint ;
				dat->CacheSize = 0 ;
			}
			break ;

		case FILEACCESSTHREAD_FUNCTION_EXIT :
			if( dat->Handle != NULL ) CloseHandle( dat->Handle ) ;
			dat->Handle = NULL ;
			goto END ;
		}

		// w߂犮CxgVOiԂɂ
		SetEvent( dat->CompEvent ) ;
	}

END:
	// G[ׂ̈ɊCxgVOiԂɂ
	SetEvent( dat->CompEvent ) ;
	dat->EndFlag = TRUE ;
	ExitThread( 1 ) ;

	return 0 ;
}



// t@CANZX֐
extern DWORD_PTR ReadOnlyFileAccessOpen( const wchar_t *Path, int UseCacheFlag, int BlockReadFlag, int UseASyncReadFlag )
{
	WINFILEACCESS *FileAccess ;
	DWORD Code ;
	DWORD High ;

//	UseCacheFlag = UseCacheFlag ;
	BlockReadFlag = BlockReadFlag ;

	FileAccess = ( WINFILEACCESS * )DXALLOC( sizeof( WINFILEACCESS ) ) ;
	if( FileAccess == NULL ) return 0 ;

	_MEMSET( FileAccess, 0, sizeof( WINFILEACCESS ) ) ;

//	// LbVgp邩ǂXbhgp邩ǂɂĂ܂
//	FileAccess->UseThread = UseCacheFlag ;

	// LbVgp邩ǂ̃tOZbg
	FileAccess->UseCacheFlag = UseCacheFlag ;
	FileAccess->ThreadData.CacheBuffer = NULL;

	// 񓯊ǂݏtOZbg
	FileAccess->UseASyncReadFlag = UseASyncReadFlag ;

	// LbVAႵ͔񓯊ǂݏsꍇ̓Xbhgp
	FileAccess->UseThread = FileAccess->UseCacheFlag || FileAccess->UseASyncReadFlag ;

	// XbhgpꍇƂȂꍇŏ𕪊
	if( FileAccess->UseThread == TRUE )
	{
		// Xbhgpꍇ̓t@CANZXpXbh𗧂Ă

		// ŏɃt@CJ邩ǂm߂Ă
		FileAccess->Handle = CreateFileW( Path, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL ) ;
		if( FileAccess->Handle == INVALID_HANDLE_VALUE )
		{
			DXFREE( FileAccess ) ;
			return 0 ;
		}
		FileAccess->Size = GetFileSize( FileAccess->Handle, &High ) ;
		FileAccess->Size |= ( ( ULONGLONG )High ) << 32 ;
		CloseHandle( FileAccess->Handle ) ;
		FileAccess->Handle = NULL ;

		// LbVp̊m
		if( FileAccess->UseCacheFlag )
		{
			FileAccess->ThreadData.CacheBuffer = (BYTE *)DXALLOC( FILEACCESSTHREAD_DEFAULT_CACHESIZE );
			if( FileAccess->ThreadData.CacheBuffer == NULL )
			{
				DXFREE( FileAccess->ThreadData.CacheBuffer ) ;
				DXFREE( FileAccess ) ;
				DXST_ERRORLOG_ADDUTF16LE( "\xd5\x30\xa1\x30\xa4\x30\xeb\x30\xad\x8a\x7f\x30\xbc\x8f\x7f\x30\xad\x30\xe3\x30\xc3\x30\xb7\x30\xe5\x30\x28\x75\xe1\x30\xe2\x30\xea\x30\x6e\x30\xba\x78\xdd\x4f\x6b\x30\x31\x59\x57\x65\x57\x30\x7e\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"t@Cǂݍ݃LbVp̊mۂɎs܂\n" @*/ ) ;
				return 0 ;
			}
		}

		// pXbhf[^
		FileAccess->ThreadData.Handle = NULL ;
		FileAccess->ThreadData.ThreadHandle = NULL ;
		FileAccess->ThreadData.FuncEvent = CreateEvent( NULL, TRUE, FALSE, NULL ) ;
		FileAccess->ThreadData.CompEvent = CreateEvent( NULL, TRUE, TRUE, NULL ) ;

		FileAccess->ThreadData.ThreadHandle = CreateThread(
												NULL,
												0,
												(LPTHREAD_START_ROUTINE)FileAccessThreadFunction, 
												&FileAccess->ThreadData,
												0,
												&FileAccess->ThreadData.ThreadID ) ;
		if( FileAccess->ThreadData.ThreadHandle == NULL )
		{
			if( FileAccess->ThreadData.CacheBuffer ) DXFREE( FileAccess->ThreadData.CacheBuffer ) ;
			CloseHandle( FileAccess->ThreadData.FuncEvent ) ;
			CloseHandle( FileAccess->ThreadData.CompEvent ) ;
			DXFREE( FileAccess ) ;
			DXST_ERRORLOG_ADDUTF16LE( "\xd5\x30\xa1\x30\xa4\x30\xeb\x30\xa2\x30\xaf\x30\xbb\x30\xb9\x30\x02\x5c\x28\x75\xb9\x30\xec\x30\xc3\x30\xc9\x30\x6e\x30\x5c\x4f\x10\x62\x6b\x30\x31\x59\x57\x65\x57\x30\x7e\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"t@CANZXpXbh̍쐬Ɏs܂\n" @*/ ) ;
			return 0 ;
		}
		SetThreadPriority( FileAccess->ThreadData.ThreadHandle, THREAD_PRIORITY_LOWEST ) ;

		// t@CI[vw߂͂ŊĂ܂
		FileAccess->ThreadData.Function = FILEACCESSTHREAD_FUNCTION_OPEN ;
		_WCSCPY( FileAccess->ThreadData.FilePath, Path ) ;

		ResetEvent( FileAccess->ThreadData.CompEvent ) ;
		SetEvent( FileAccess->ThreadData.FuncEvent ) ;

		// w߂I܂ő҂
		WaitForSingleObject( FileAccess->ThreadData.CompEvent, INFINITE ) ;
		if( FileAccess->ThreadData.ErrorFlag == TRUE )
		{
			if( FileAccess->ThreadData.CacheBuffer ) DXFREE( FileAccess->ThreadData.CacheBuffer ) ;
			CloseHandle( FileAccess->ThreadData.FuncEvent ) ;
			CloseHandle( FileAccess->ThreadData.CompEvent ) ;
			do
			{
				Sleep( 0 ) ;
				GetExitCodeThread( FileAccess->ThreadData.ThreadHandle, &Code ) ;
			}while( Code == STILL_ACTIVE ) ;
			CloseHandle( FileAccess->ThreadData.ThreadHandle ) ;
			DXFREE( FileAccess ) ;
			DXST_ERRORLOG_ADDUTF16LE( "\xd5\x30\xa1\x30\xa4\x30\xeb\x30\x6e\x30\xaa\x30\xfc\x30\xd7\x30\xf3\x30\x6b\x30\x31\x59\x57\x65\x57\x30\x7e\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"t@C̃I[vɎs܂\n" @*/ ) ;
			return 0 ;
		}
	}
	else
	{
		// XbhgpȂꍇ͂̏Ńt@CJ
		FileAccess->Handle = CreateFileW( Path, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL ) ;
		if( FileAccess->Handle == INVALID_HANDLE_VALUE )
		{
			DXFREE( FileAccess ) ;
			return 0 ;
		}
		FileAccess->Size = GetFileSize( FileAccess->Handle, &High ) ;
		FileAccess->Size |= ( ( ULONGLONG )High ) << 32 ;
	}
	FileAccess->EofFlag = FALSE ;
	FileAccess->Position = 0 ;

	return ( DWORD_PTR )FileAccess ;
}

extern int ReadOnlyFileAccessClose( DWORD_PTR Handle )
{
	WINFILEACCESS *FileAccess = ( WINFILEACCESS * )Handle ;
	BOOL Result;
	DWORD Code ;

	// XbhgpꍇƂȂꍇŏ𕪊
	if( FileAccess->UseThread == TRUE )
	{
		// ȑO̎w߂oĂꍇׂ̈ɎwߊCxgVOiԂɂȂ܂ő҂
		WaitForSingleObject( FileAccess->ThreadData.CompEvent, INFINITE ) ;

		// XbhɏIw߂o
		FileAccess->ThreadData.Function = FILEACCESSTHREAD_FUNCTION_EXIT ;
		ResetEvent( FileAccess->ThreadData.CompEvent ) ;
		SetEvent( FileAccess->ThreadData.FuncEvent ) ;

		// w߂I܂ő҂
		WaitForSingleObject( FileAccess->ThreadData.CompEvent, INFINITE ) ;

		// XbhÎ҂
		do
		{
			Sleep(1);
			GetExitCodeThread( FileAccess->ThreadData.ThreadHandle, &Code );
		}while( Code == STILL_ACTIVE );

		// LbVgpĂꍇ̓LbVpJ
		if( FileAccess->ThreadData.CacheBuffer )
			DXFREE( FileAccess->ThreadData.CacheBuffer ) ;

		// CxgXbh
		CloseHandle( FileAccess->ThreadData.ThreadHandle ) ;
		CloseHandle( FileAccess->ThreadData.CompEvent ) ;
		CloseHandle( FileAccess->ThreadData.FuncEvent ) ;
		Result = 0 ;
	}
	else
	{
		// gpĂȂꍇ͂̏ŃnhďI
		Result = CloseHandle( FileAccess->Handle ) ;
	}
	DXFREE( FileAccess ) ;

	return Result != 0 ? 0 : -1/*EOF*/ ;
}

extern LONGLONG ReadOnlyFileAccessTell( DWORD_PTR Handle )
{
	WINFILEACCESS *FileAccess = ( WINFILEACCESS * )Handle ;

	return ( LONGLONG )FileAccess->Position ;
}

extern int ReadOnlyFileAccessSeek( DWORD_PTR Handle, LONGLONG SeekPoint, int SeekType )
{
	WINFILEACCESS *FileAccess = ( WINFILEACCESS * )Handle ;
	ULONGLONG Pos = 0 ;
	int Result ;

	switch( SeekType )
	{
	case SEEK_CUR :
		if( FileAccess->Position + SeekPoint < 0 )
		{
			Pos = 0 ;
		}
		else
		{
			Pos = FileAccess->Position + SeekPoint ;
		}
		break ;

	case SEEK_END :
		if( FileAccess->Size + SeekPoint < 0 )
		{
			Pos = 0 ;
		}
		else
		{
			Pos = FileAccess->Size + SeekPoint ;
		}
		break ;

	case SEEK_SET :
		if( SeekPoint < 0 )
		{
			Pos = 0 ;
		}
		else
		{
			Pos = ( ULONGLONG )SeekPoint ;
		}
		break ;
	}

	// XbhgpĂ邩ǂŏ𕪊
	if( FileAccess->UseThread == TRUE )
	{
		// ȑO̎w߂oĂꍇׂ̈ɎwߊCxgVOiԂɂȂ܂ő҂
		WaitForSingleObject( FileAccess->ThreadData.CompEvent, INFINITE ) ;

		// XbhɃt@CʒuύXw߂o
		FileAccess->ThreadData.Function = FILEACCESSTHREAD_FUNCTION_SEEK ;
		FileAccess->ThreadData.SeekPoint = Pos ;
		ResetEvent( FileAccess->ThreadData.CompEvent ) ;
		SetEvent( FileAccess->ThreadData.FuncEvent ) ;
	}
	else
	{
		// t@CANZXʒuύX
		Result = SetFilePointer64( FileAccess->Handle, Pos ) ;
		if( Result == -1 ) return -1 ;
	}

	// ʒuۑĂ
	FileAccess->Position = Pos ;

	// I[`FbNtO|
	FileAccess->EofFlag = FALSE ;

	// I
	return 0 ;
}

extern size_t ReadOnlyFileAccessRead( void *Buffer, size_t BlockSize, size_t DataNum, DWORD_PTR Handle )
{
	WINFILEACCESS *FileAccess = ( WINFILEACCESS * )Handle ;
	DWORD Result, BytesRead ;

	if( BlockSize == 0 ) return 0 ;

	// I[`FbN
	if( FileAccess->Position == FileAccess->Size )
	{
		FileAccess->EofFlag = TRUE ;
		return 0 ;
	}

	// ڐ
	if( BlockSize * DataNum + FileAccess->Position > FileAccess->Size )
	{
		DataNum = ( size_t )( ( FileAccess->Size - FileAccess->Position ) / BlockSize ) ;
	}
	
	if( DataNum == 0 )
	{
		FileAccess->EofFlag = TRUE ;
		return 0 ;
	}

	// XbhgpĂ邩ǂŏ𕪊
	if( FileAccess->UseThread == TRUE )
	{
		// ȑO̎w߂oĂꍇׂ̈ɎwߊCxgVOiԂɂȂ܂ő҂
		WaitForSingleObject( FileAccess->ThreadData.CompEvent, INFINITE ) ;

		// XbhɃt@Cǂݍݎw߂o
		FileAccess->ThreadData.Function = FILEACCESSTHREAD_FUNCTION_READ ;
		FileAccess->ThreadData.ReadBuffer = Buffer ;
		FileAccess->ThreadData.ReadPosition = FileAccess->Position ;
		FileAccess->ThreadData.ReadSize = ( DWORD )( BlockSize * DataNum ) ;
		ResetEvent( FileAccess->ThreadData.CompEvent ) ;
		SetEvent( FileAccess->ThreadData.FuncEvent ) ;

		// 񓯊ǂŏ𕪊
		if( FileAccess->UseASyncReadFlag == FALSE )
		{
			// ǂݍ݂̏ꍇ͎w߂܂ő҂
			WaitForSingleObject( FileAccess->ThreadData.CompEvent, INFINITE ) ;
		}

		BytesRead = ( DWORD )( BlockSize * DataNum ) ;
		Result = 1 ;
	}
	else
	{
		Result = ( DWORD )ReadFile( FileAccess->Handle, Buffer, DWORD( BlockSize * DataNum ), &BytesRead, NULL ) ;
	}

	FileAccess->Position += ( DWORD )( DataNum * BlockSize ) ;
	return Result != 0 ? BytesRead / BlockSize : 0 ;
}

extern int ReadOnlyFileAccessEof( DWORD_PTR Handle )
{
	WINFILEACCESS *FileAccess = (WINFILEACCESS *)Handle ;

	return FileAccess->EofFlag ? EOF : 0 ;
}

extern int ReadOnlyFileAccessIdleCheck( DWORD_PTR Handle )
{
	WINFILEACCESS *FileAccess = (WINFILEACCESS *)Handle ;

	if( FileAccess->UseThread == TRUE )
	{
		return WaitForSingleObject( FileAccess->ThreadData.CompEvent, 0 ) == WAIT_TIMEOUT ? FALSE : TRUE ;
	}
	else
	{
		return TRUE ;
	}
}

extern int ReadOnlyFileAccessChDir( const wchar_t *Path )
{
	return SetCurrentDirectoryW( Path ) ;
}

extern int ReadOnlyFileAccessGetDir( wchar_t *Buffer )
{
	return ( int )GetCurrentDirectoryW( FILEPATH_MAX, Buffer ) ;
}

static void _WIN32_FIND_DATA_To_FILEINFO( WIN32_FIND_DATAW *FindData, FILEINFOW *FileInfo )
{
	// t@C̃Rs[
	_WCSCPY( FileInfo->Name, FindData->cFileName );

	// fBNgǂ̃tOZbg
	FileInfo->DirFlag = (FindData->dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) != 0 ? TRUE : FALSE;

	// t@C̃TCYZbg
	FileInfo->Size = ( LONGLONG )( ( ( ( ULONGLONG )FindData->nFileSizeHigh ) << 32 ) + FindData->nFileSizeLow ) ;

	// t@C^Cۑ
	_FileTimeToLocalDateData( &FindData->ftCreationTime, &FileInfo->CreationTime );
	_FileTimeToLocalDateData( &FindData->ftLastWriteTime, &FileInfo->LastWriteTime );
}

// ߂l: -1=G[  -1ȊO=FindHandle
extern DWORD_PTR ReadOnlyFileAccessFindFirst( const wchar_t *FilePath, FILEINFOW *Buffer )
{
	WIN32_FIND_DATAW FindData ;
	HANDLE FindHandle ;

	FindHandle = FindFirstFileW( FilePath, &FindData ) ;
	if( FindHandle == INVALID_HANDLE_VALUE )
	{
		return ( DWORD_PTR )-1;
	}

	if( Buffer )
	{
		_WIN32_FIND_DATA_To_FILEINFO( &FindData, Buffer ) ;
	}

	return (DWORD_PTR)FindHandle;
}

// ߂l: -1=G[  0=
extern int ReadOnlyFileAccessFindNext( DWORD_PTR FindHandle, FILEINFOW *Buffer )
{
	WIN32_FIND_DATAW FindData ;

	if( FindNextFileW( (HANDLE)FindHandle, &FindData ) == 0 )
	{
		return -1 ;
	}

	if( Buffer )
	{
		_WIN32_FIND_DATA_To_FILEINFO( &FindData, Buffer ) ;
	}

	return 0 ;
}

// ߂l: -1=G[  0=
extern int ReadOnlyFileAccessFindClose( DWORD_PTR FindHandle )
{
	// OȊOԂĂ琬
	return FindClose( (HANDLE)FindHandle ) != 0 ? 0 : -1;
}







#ifdef DX_USE_NAMESPACE

}

#endif // DX_USE_NAMESPACE

