// -------------------------------------------------------------------------------
// 
// 		cwCu		֌WvOwb_t@C
// 
// 				Ver 3.14a
// 
// -------------------------------------------------------------------------------

#ifndef __DXMEMORY_H__
#define __DXMEMORY_H__

// CN[h ------------------------------------------------------------------
#include "DxCompileConfig.h"
#include "DxThread.h"

#ifdef DX_USE_NAMESPACE

namespace DxLib
{

#endif // DX_USE_NAMESPACE

// }N` --------------------------------------------------------------------

#ifdef __64BIT__
#define ALLOCNAMELENGTH			(32)
#define DXALLOC_INFO_SIZE		(64)
#else // __64BIT__
#define ALLOCNAMELENGTH			(16)
#define DXALLOC_INFO_SIZE		(32)
#endif // __64BIT__

#define DXADDRESS	(DXALLOC_INFO_SIZE * 2)
#define DXADDSIZE	(DXALLOC_INFO_SIZE * 3)

// mیn֐
//#ifdef DX_USE_DXLIB_MEM_DUMP
#if !defined( __BCC ) || defined( _DEBUG )
	#define DXALLOC( size )			NS_DxAlloc( (size), __FILE__, __LINE__ )
	#define DXCALLOC( size )		NS_DxCalloc( (size), __FILE__, __LINE__ )
	#define DXREALLOC( mem, size )	NS_DxRealloc( (mem), (size), __FILE__, __LINE__ )
	#define DXFREE( mem )			NS_DxFree( (mem) )
#else
	#define DXALLOC( size )			NS_DxAlloc( (size), "", 0 )
	#define DXCALLOC( size )		NS_DxCalloc( (size), "", 0 )
	#define DXREALLOC( mem, size )	NS_DxRealloc( (mem), (size), "", 0 )
	#define DXFREE( mem )			NS_DxFree( (mem) )
#endif

//#else
//	#define DXALLOC( size )			AllocWrap( (size) )
//	#define DXCALLOC( size )		CallocWrap( (size) )
//	#define DXREALLOC( mem, size )	ReallocWrap( (mem), (size) )
//	#define DXFREE( mem )			FreeWrap( (mem) )
//	#define DXALLOC( size )			malloc( (size) )
//	#define DXCALLOC( size )		calloc( 1, (size) )
//	#define DXREALLOC( mem, size )	realloc( (mem), (size) )
//	#define DXFREE( mem )			free( (mem) )
//#endif


#define ALLOCMEM_CATEGORY_2_SHIFT_NUM			(5)							// JeS[Q̐( 32 )2̏搔

#ifdef __64BIT__
#define ALLOCMEMTAG_NAMELENGTH					(18)						// mۃ̖O
#define ALLOCMEM_CATEGORY_1_NUM					(64)						// JeS[P̐(  0 ` ALLOCMEM_CATEGORY_2_SHIFT_NUM ̃JeS͎gpȂ( łȂ ) )
#define ALLOCMEM_SIZE_TYPE						ULONGLONG					// mۃ̃TCY̌^
#else // __64BIT__
#define ALLOCMEMTAG_NAMELENGTH					(38)						// mۃ̖O
#define ALLOCMEM_CATEGORY_1_NUM					(32)						// JeS[P̐(  0 ` ALLOCMEM_CATEGORY_2_SHIFT_NUM ̃JeS͎gpȂ( łȂ ) )
#define ALLOCMEM_SIZE_TYPE						DWORD						// mۃ̃TCY̌^
#endif // __64BIT__

#define ALLOCMEMTAG_SIZE						(64)						// ALLOCMEMTAG\̂̃TCY
#define ALLOCMEMTAG_DEBUGAREA_SIZE				(16)						// fobOp̒lŖ߂̈̃TCY
#define ALLOCMEMTAG_TOTAL_SIZE					( ALLOCMEMTAG_SIZE + ALLOCMEMTAG_DEBUGAREA_SIZE * 2 )	// ̃mۂŕKvȃ^ÕTCY

#define ALLOCMEMTAG_FLAG_LINE_BIT_16			(0x01)						// sԍ16bit( WORD ł 65535s܂ł\łȂ̂ŁA262143s܂ŕ\ł悤ɂ邽߂̑Ή )
#define ALLOCMEMTAG_FLAG_LINE_BIT_17			(0x02)						// sԍ17bit(  )
#define ALLOCMEMTAG_FLAG_USE					(0x04)						// gpĂ邩ǂ
#define ALLOCMEMTAG_FLAG_NEXT_CONNECT			(0x08)						// Next ̃̈ƃAhXAĂ邩ǂ( I[̏ꍇ )
#define ALLOCMEMTAG_FLAG_PREV_CONNECT			(0x10)						// Prev ̃̈ƃAhXAĂ邩ǂ( [̏ꍇ )

// ̃^Oւ̃AhX擾( ALLOCMEMTAG_FLAG_NEXT_CONNECT Ăꍇ̂ݗL )
#define ALLOCMEMTAG_NEXT( TAG )					( ( ALLOCMEMTAG * )( ( ( BYTE * )(TAG) ) + (TAG)->Size + ALLOCMEMTAG_TOTAL_SIZE ) )


// \̒` --------------------------------------------------------------------

// mۃ̃^O
struct ALLOCMEMTAG /* TCY ALLOCMEMTAG_SIZE byte ɂȂ悤ɒ */
{
	char					Name[ ALLOCMEMTAG_NAMELENGTH ] ;	// t@CpX
	BYTE					Flag ;								// tO
	BYTE					Padding ;							// \
	WORD					ID ;								// hc
	WORD					Line ;								// sԍ
	ALLOCMEM_SIZE_TYPE		Size ;								// ̈TCY
	ALLOCMEMTAG *			Prev ;								// Õ^Oւ̃|C^( [̏ꍇ NULL )A̃^Oւ̃AhX ALLOCMEMTAG_NEXT gp
	ALLOCMEMTAG *			ListPrev ;							// Xg̈Õ^Oւ̃|C^( [̏ꍇ NULL )
	ALLOCMEMTAG *			ListNext ;							// Xg̈̃^Oւ̃|C^( I[̏ꍇ NULL )
	struct MEMORYHEAP *		Owner ;								// ^OĂq[vւ̃|C^
} ;

// q[vpɊmۂꂽ̏
struct HEAPMEMINFO
{
	void *					Address ;							// q[vpɊmۂꂽ̐擪AhX
	ALLOCMEM_SIZE_TYPE		Size ;								// q[vpɊmۂꂽ̃TCY

	HEAPMEMINFO *			Prev ;								// Õq[vpɊmۂꂽ̏ւ̃|C^( [̏ꍇ NULL )
	HEAPMEMINFO *			Next ;								// ̃q[vpɊmۂꂽ̏ւ̃|C^( I[̏ꍇ NULL )
} ;

// q[v
struct HEAPINFO
{
	HEAPMEMINFO				*FirstHeap ;						// q[vpɊmۂꂽ̏̃Xg̍ŏ̏ւ̃|C^

	int						FreeTagNum ;						// 󂫃^O̐
	ALLOCMEM_SIZE_TYPE		MaxFreeSize ;						// mۉ\ȋ󂫃̍őTCY
	ALLOCMEM_SIZE_TYPE		TotalFreeSize ;						// 󂫃̍vTCY
#ifdef __64BIT__
	ULONGLONG				FreeTagBitList1 ;					// JeSP̋󂫃JeS̃rbgXg
#else // __64BIT__
	DWORD					FreeTagBitList1 ;					// JeSP̋󂫃JeS̃rbgXg
#endif __64BIT__
	DWORD					FreeTagBitList2[ ALLOCMEM_CATEGORY_1_NUM ] ;										// eJeSP̋󂫃JeSQ̃rbgXg
	ALLOCMEMTAG *			FreeFirstTag[ ALLOCMEM_CATEGORY_1_NUM ][ 2 << ALLOCMEM_CATEGORY_2_SHIFT_NUM ] ;		// eJeS̋󂫃ŏ̃^Oւ̃|C^
	ALLOCMEMTAG *			FreeLastTag[  ALLOCMEM_CATEGORY_1_NUM ][ 2 << ALLOCMEM_CATEGORY_2_SHIFT_NUM ] ;		// eJeS̋󂫃Ō̃^Oւ̃|C^

	int						UseTagNum ;							// gpĂ郁̐
	ALLOCMEM_SIZE_TYPE		TotalUseSize ;						// gpĂ郁̍vTCY
	ALLOCMEMTAG *			UseFirstTag ;						// gp̍ŏ̃^Oւ̃|C^
	ALLOCMEMTAG *			UseLastTag ;						// gp̍Ō̃^Oւ̃|C^
} ;


// mۂ̏
#ifdef __64BIT__
struct ALLOCMEM
{
	char					Name[ ALLOCNAMELENGTH ] ;			// t@CpX
	int						ID ;								// hc
	int						Line ;								// sԍ
	size_t					Size ;								// mۃTCY
	struct ALLOCMEM			*Back, *Next ;						// ƑO̊mۃւ̃|C^
} ;
#else // __64BIT__
struct ALLOCMEM
{
	char					Name[ ALLOCNAMELENGTH ] ;			// t@CpX
	unsigned short			ID ;								// hc
	unsigned short			Line ;								// sԍ
	size_t					Size ;								// mۃTCY
	struct ALLOCMEM			*Back, *Next ;						// ƑO̊mۃւ̃|C^
} ;
#endif // __64BIT__

// ֌W̏\
struct MEMORYDATA
{
	ALLOCMEM				AllocMemoryAnchor ;					// mۏ̍Ō
	char					AllocMemoryAnchorDummy[DXALLOC_INFO_SIZE * 2] ;
	ALLOCMEM				*AllocMemoryFirst ;					// mۏ̐擪
	unsigned short			AllocMemoryID ;						// mۂɊ蓖Ăhc
	size_t					AllocMemorySize ;					// mۂĂ郁̑
	int						AllocMemoryNum ;					// CuŊmۂ̐
	int						AllocMemoryPrintFlag ;				// mۂ鎞ɏo͂邩ǂ̃tO
	int						AllocMemorySizeOutFlag ;			// mۂsxɊmۃ̑ʂOɏo͂邩ǂ̃tO
	int						AllocMemoryErrorCheckFlag ;			// mۂsxɊmۃ̏񂪔jĂȂ`FbN邩ǂ̃tO
	size_t					AllocTrapSize ;						// 񋓑ΏۂɂmۃTCY

#if defined( DX_THREAD_SAFE ) || defined( DX_THREAD_SAFE_NETWORK_ONLY )
	int						InitMemoryAllocCriticalSection ;	// MemoryAllocCriticalSection ̏ςł邩ǂ̃tO
	DX_CRITICAL_SECTION		MemoryAllocCriticalSection ;		// mۏpNeBJZNV
#endif
} ;

// e[u-----------------------------------------------------------------------

// ϐ錾 --------------------------------------------------------------

// ֌W̏
extern MEMORYDATA MemData ;

// ֐vg^Cv錾-----------------------------------------------------------

extern void			MemoryDump( void *buffer, int size ) ;
extern int			DxCheckAlloc( ALLOCMEM *Alloc ) ;										// mۏ񂪔j󂳂ĂȂׂ

// bp[֐
extern	void 		*AllocWrap( size_t AllocSize ) ;										// mۂ
extern	void 		*CallocWrap( size_t AllocSize ) ;										// mۂĂOŏ
extern	void		*ReallocWrap( void *Memory, size_t AllocSize ) ;						// ̍Ċmۂs
extern	void		FreeWrap( void *Memory ) ;												// 

#ifdef DX_USE_NAMESPACE

}

#endif // DX_USE_NAMESPACE

#endif // __DXMEMORY_H__
